# class OpenSSL::Timestamp::TokenInfo

Immutable and read-only representation of a timestamp token info from a `Response`.

### Public Class Methods

OpenSSL::Timestamp::TokenInfo.new(file) → token-info
OpenSSL::Timestamp::TokenInfo.new(string) → token-info
Source

    static VALUE
    ossl_ts_token_info_initialize(VALUE self, VALUE der)
    {
        TS_TST_INFO *info = DATA_PTR(self);
        BIO *in;

        der = ossl_to_der_if_possible(der);
        in  = ossl_obj2bio(&der);
        info = d2i_TS_TST_INFO_bio(in, &info);
        BIO_free(in);
        if (!info) {
            DATA_PTR(self) = NULL;
            ossl_raise(eTimestampError, "Error when decoding the timestamp token info");
        }
        DATA_PTR(self) = info;

        return self;
    }

Creates a `TokenInfo` from a `File` or `string` parameter, the corresponding `File` or `string` must be DER-encoded. Please note that `TokenInfo` is an immutable read-only class. If you’d like to create timestamps please refer to `Factory` instead.

### Public Instance Methods

algorithm → string or nil
Source

    static VALUE
    ossl_ts_token_info_get_algorithm(VALUE self)
    {
        TS_TST_INFO *info;
        TS_MSG_IMPRINT *mi;
        X509_ALGOR *algo;

        GetTSTokenInfo(self, info);
        mi = TS_TST_INFO_get_msg_imprint(info);
        algo = TS_MSG_IMPRINT_get_algo(mi);
        return get_asn1obj(algo->algorithm);
    }

Returns the ‘short name’ of the object identifier representing the algorithm that was used to derive the message imprint digest. For valid timestamps, this is the same value that was already given in the `Request`. If status is GRANTED or GRANTED_WITH_MODS, this is never `nil`.

### Example:¶ ↑

    algo = token_info.algorithm
    puts algo                -> "SHA1"

gen_time → Time
Source

    static VALUE
    ossl_ts_token_info_get_gen_time(VALUE self)
    {
        TS_TST_INFO *info;

        GetTSTokenInfo(self, info);
        return asn1time_to_time(TS_TST_INFO_get_time(info));
    }

Returns time when this timestamp token was created. If status is GRANTED or GRANTED_WITH_MODS, this is never `nil`.

msg_imprint → string.
Source

    static VALUE
    ossl_ts_token_info_get_msg_imprint(VALUE self)
    {
        TS_TST_INFO *info;
        TS_MSG_IMPRINT *mi;
        ASN1_OCTET_STRING *hashed_msg;
        VALUE ret;

        GetTSTokenInfo(self, info);
        mi = TS_TST_INFO_get_msg_imprint(info);
        hashed_msg = TS_MSG_IMPRINT_get_msg(mi);
        ret = rb_str_new((const char *)hashed_msg->data, hashed_msg->length);

        return ret;
    }

Returns the message imprint digest. For valid timestamps, this is the same value that was already given in the `Request`. If status is GRANTED or GRANTED_WITH_MODS, this is never `nil`.

### Example:¶ ↑

    mi = token_info.msg_imprint
    puts mi                -> "DEADBEEF"

nonce → BN or nil
Source

    static VALUE
    ossl_ts_token_info_get_nonce(VALUE self)
    {
        TS_TST_INFO *info;
        const ASN1_INTEGER *nonce;

        GetTSTokenInfo(self, info);
        if (!(nonce = TS_TST_INFO_get_nonce(info)))
            return Qnil;

        return asn1integer_to_num(nonce);
    }

If the timestamp token is valid then this field contains the same nonce that was passed to the timestamp server in the initial `Request`.

ordering → true, falses or nil
Source

    static VALUE
    ossl_ts_token_info_get_ordering(VALUE self)
    {
        TS_TST_INFO *info;

        GetTSTokenInfo(self, info);
        return TS_TST_INFO_get_ordering(info) ? Qtrue : Qfalse;
    }

If the ordering field is missing, or if the ordering field is present and set to false, then the genTime field only indicates the time at which the time-stamp token has been created by the TSA. In such a case, the ordering of time-stamp tokens issued by the same TSA or different TSAs is only possible when the difference between the genTime of the first time-stamp token and the genTime of the second time-stamp token is greater than the sum of the accuracies of the genTime for each time-stamp token.

If the ordering field is present and set to true, every time-stamp token from the same TSA can always be ordered based on the genTime field, regardless of the genTime accuracy.

policy_id → string or nil
Source

    static VALUE
    ossl_ts_token_info_get_policy_id(VALUE self)
    {
        TS_TST_INFO *info;

        GetTSTokenInfo(self, info);
        return get_asn1obj(TS_TST_INFO_get_policy_id(info));
    }

Returns the timestamp policy object identifier of the policy this timestamp was created under. If status is GRANTED or GRANTED_WITH_MODS, this is never `nil`.

### Example:¶ ↑

    id = token_info.policy_id
    puts id                 -> "1.2.3.4.5"

serial_number → BN or nil
Source

    static VALUE
    ossl_ts_token_info_get_serial_number(VALUE self)
    {
        TS_TST_INFO *info;

        GetTSTokenInfo(self, info);
        return asn1integer_to_num(TS_TST_INFO_get_serial(info));
    }

Returns serial number of the timestamp token. This value shall never be the same for two timestamp tokens issued by a dedicated timestamp authority. If status is GRANTED or GRANTED_WITH_MODS, this is never `nil`.

to_der → string
Source

    static VALUE
    ossl_ts_token_info_to_der(VALUE self)
    {
        TS_TST_INFO *info;

        GetTSTokenInfo(self, info);
        return asn1_to_der((void *)info, (int (*)(void *, unsigned char **))i2d_TS_TST_INFO);
    }

Returns the `TokenInfo` in DER-encoded form.

to_text ()
Source

    static VALUE
    ossl_ts_token_info_to_text(VALUE self)
    {
        TS_TST_INFO *info;
        BIO *out;

        GetTSTokenInfo(self, info);

        out = BIO_new(BIO_s_mem());
        if (!out) ossl_raise(eTimestampError, NULL);

        if (!TS_TST_INFO_print_bio(out, info)) {
            BIO_free(out);
            ossl_raise(eTimestampError, NULL);
        }

        return ossl_membio2str(out);
    }

version → Integer or nil
Source

    static VALUE
    ossl_ts_token_info_get_version(VALUE self)
    {
        TS_TST_INFO *info;

        GetTSTokenInfo(self, info);
        return LONG2NUM(TS_TST_INFO_get_version(info));
    }

Returns the version number of the token info. With compliant servers, this value should be `1` if present. If status is GRANTED or GRANTED_WITH_MODS.